<div id="cardContainer">
    <div class="card">Card 1</div>
    <div class="card">Card 2</div>
    <div class="card">Card 3</div>
    <div class="card">Card 4</div>
    <div class="card">Card 5</div>
    <div class="card">Card 6</div>
    <div class="card">Card 7</div>
    <div class="card">Card 8</div>
    <div class="card">Card 9</div>
</div>
<div id="dotContainer">
</div>
<style>
    #cardContainer {
        display: flex;
        flex-wrap: wrap;
        transition: transform 0.5s ease-in-out;
    }

    .card {
        width: calc(50% - 20px);
        height: 200px;
        margin: 10px;
        background-color: lightgray;
        text-align: center;
        line-height: 200px;
        transition: opacity 0.5s ease-in-out;
    }

    #dotContainer {
        display: flex;
        justify-content: center;
        margin-top: 20px;
    }

    .dot {
        width: 10px;
        height: 10px;
        margin: 0 10px;
        border-radius: 50%;
        background-color: gray;
        cursor: pointer;
        transition: background-color 0.5s ease-in-out;
    }

    .active {
        background-color: black;
    }
</style>
<script>
    var cardContainer = document.getElementById("cardContainer");
    var cards = cardContainer.children;
    var currentIndex = 0;
    var cardsPerPage = 4;

    function updateCards() {
        for (let i = 0; i < cards.length; i++) {
            cards[i].style.display = "none";
            cards[i].style.opacity = 0;
        }

        for (let i = currentIndex; i < currentIndex + cardsPerPage; i++) {
            const card = cards[i % cards.length];
            card.style.display = "block";
            setTimeout(function () {
                card.style.opacity = 1;
            }, i * 100);
        }
    }

    function updateDots() {
        const dotContainer = document.getElementById("dotContainer");
        dotContainer.innerHTML = "";

        for (let i = 0; i < Math.ceil(cards.length / cardsPerPage); i++) {
            const dot = document.createElement("div");
            dot.classList.add("dot");

            if (i === Math.floor(currentIndex / cardsPerPage)) {
                dot.classList.add("active");
            }

            dot.addEventListener("click", function () {
                currentIndex = i * cardsPerPage;
                updateCards();
                updateDots();
            });

            dotContainer.appendChild(dot);
        }
    }

    updateCards();
    updateDots();
</script>